# Generated by go2rpm
# Needs to run with make which needs network access
%bcond_with check

# https://github.com/cockroachdb/cockroach
%global goipath         github.com/cockroachdb/cockroach
Version:                19.2.0
%global tag             v19.2.0-alpha.00000000
%global distprefix      %{nil}

%gometa

%global common_description %{expand:
CockroachDB is a distributed SQL database built on a transactional and
strongly-consistent key-value store. It scales horizontally; survives disk,
machine, rack, and even datacenter failures with minimal latency disruption and
no manual intervention; supports strongly-consistent ACID transactions; and
provides a familiar SQL API for structuring, manipulating, and querying data.}

%global golicenses      LICENSE
%global godocs          docs CONTRIBUTING.md README.md

Name:           %{goname}
Release:        5.alpha%{?dist}
Summary:        Open source, cloud-native SQL database

# Upstream license specification: Apache-2.0 and BSD-2-Clause and BSD-3-Clause
License:        ASL 2.0 and MIT and BSD
Source0:        %{gosource}
# Use int64 in union_find.go for 32 bits compatibility
Patch0:         0001-Use-int64-in-union_find.go-for-32-bits-compatibility.patch

BuildRequires:  golang(cloud.google.com/go/storage)
BuildRequires:  golang(github.com/abourget/teamcity)
BuildRequires:  golang(github.com/andy-kimball/arenaskl)
BuildRequires:  golang(github.com/armon/circbuf)
BuildRequires:  golang(github.com/aws/aws-sdk-go/aws)
BuildRequires:  golang(github.com/aws/aws-sdk-go/aws/awsutil)
BuildRequires:  golang(github.com/aws/aws-sdk-go/aws/credentials)
BuildRequires:  golang(github.com/aws/aws-sdk-go/aws/session)
BuildRequires:  golang(github.com/aws/aws-sdk-go/service/s3)
BuildRequires:  golang(github.com/aws/aws-sdk-go/service/s3/s3manager)
BuildRequires:  golang(github.com/axiomhq/hyperloglog)
BuildRequires:  golang(github.com/Azure/azure-storage-blob-go/azblob)
BuildRequires:  golang(github.com/backtrace-labs/go-bcd)
BuildRequires:  golang(github.com/benesch/cgosymbolizer)
BuildRequires:  golang(github.com/biogo/store/llrb)
BuildRequires:  golang(github.com/cenkalti/backoff)
BuildRequires:  golang(github.com/cockroachdb/apd)
BuildRequires:  golang(github.com/cockroachdb/circuitbreaker)
BuildRequires:  golang(github.com/cockroachdb/cmux)
BuildRequires:  golang(github.com/cockroachdb/cockroach-go/crdb)
BuildRequires:  golang(github.com/cockroachdb/returncheck)
BuildRequires:  golang(github.com/cockroachdb/ttycolor)
BuildRequires:  golang(github.com/codahale/hdrhistogram)
BuildRequires:  golang(github.com/docker/distribution/reference)
BuildRequires:  golang(github.com/docker/docker/api/types)
BuildRequires:  golang(github.com/docker/docker/api/types/container)
BuildRequires:  golang(github.com/docker/docker/api/types/events)
BuildRequires:  golang(github.com/docker/docker/api/types/filters)
BuildRequires:  golang(github.com/docker/docker/api/types/network)
BuildRequires:  golang(github.com/docker/docker/client)
BuildRequires:  golang(github.com/docker/docker/pkg/jsonmessage)
BuildRequires:  golang(github.com/docker/docker/pkg/stdcopy)
BuildRequires:  golang(github.com/docker/go-connections/nat)
BuildRequires:  golang(github.com/dustin/go-humanize)
BuildRequires:  golang(github.com/elastic/gosigar)
BuildRequires:  golang(github.com/elazarl/go-bindata-assetfs)
BuildRequires:  golang(github.com/facebookgo/clock)
BuildRequires:  golang(github.com/getsentry/raven-go)
BuildRequires:  golang(github.com/ghemawat/stream)
BuildRequires:  golang(github.com/go-sql-driver/mysql)
BuildRequires:  golang(github.com/gogo/protobuf/jsonpb)
BuildRequires:  golang(github.com/gogo/protobuf/proto)
BuildRequires:  golang(github.com/gogo/protobuf/protoc-gen-gogo/descriptor)
BuildRequires:  golang(github.com/gogo/protobuf/sortkeys)
BuildRequires:  golang(github.com/gogo/protobuf/types)
BuildRequires:  golang(github.com/gogo/protobuf/vanity)
BuildRequires:  golang(github.com/gogo/protobuf/vanity/command)
BuildRequires:  golang(github.com/golang-commonmark/markdown)
BuildRequires:  golang(github.com/golang/leveldb/db)
BuildRequires:  golang(github.com/golang/leveldb/table)
BuildRequires:  golang(github.com/golang/protobuf/proto)
BuildRequires:  golang(github.com/golang/snappy)
BuildRequires:  golang(github.com/google/btree)
BuildRequires:  golang(github.com/google/go-github/github)
BuildRequires:  golang(github.com/google/pprof/driver)
BuildRequires:  golang(github.com/google/pprof/profile)
BuildRequires:  golang(github.com/grpc-ecosystem/grpc-gateway/runtime)
BuildRequires:  golang(github.com/grpc-ecosystem/grpc-gateway/utilities)
BuildRequires:  golang(github.com/grpc-ecosystem/grpc-opentracing/go/otgrpc)
BuildRequires:  golang(github.com/jackc/pgx)
BuildRequires:  golang(github.com/jackc/pgx/pgproto3)
BuildRequires:  golang(github.com/jackc/pgx/pgtype)
BuildRequires:  golang(github.com/kisielk/gotool)
BuildRequires:  golang(github.com/knz/go-libedit)
BuildRequires:  golang(github.com/knz/strtime)
BuildRequires:  golang(github.com/kr/pretty)
BuildRequires:  golang(github.com/kr/text)
BuildRequires:  golang(github.com/lib/pq)
BuildRequires:  golang(github.com/lib/pq/oid)
BuildRequires:  golang(github.com/lightstep/lightstep-tracer-go)
BuildRequires:  golang(github.com/linkedin/goavro)
BuildRequires:  golang(github.com/maruel/panicparse/stack)
BuildRequires:  golang(github.com/marusama/semaphore)
BuildRequires:  golang(github.com/mattn/go-isatty)
BuildRequires:  golang(github.com/MichaelTJones/walk)
BuildRequires:  golang(github.com/mitchellh/reflectwalk)
BuildRequires:  golang(github.com/montanaflynn/stats)
BuildRequires:  golang(github.com/nlopes/slack)
BuildRequires:  golang(github.com/olekukonko/tablewriter)
BuildRequires:  golang(github.com/opentracing/opentracing-go)
BuildRequires:  golang(github.com/opentracing/opentracing-go/log)
BuildRequires:  golang(github.com/openzipkin-contrib/zipkin-go-opentracing)
BuildRequires:  golang(github.com/petermattis/goid)
BuildRequires:  golang(github.com/pkg/errors)
BuildRequires:  golang(github.com/pmezard/go-difflib/difflib)
BuildRequires:  golang(github.com/prometheus/client_golang/prometheus)
BuildRequires:  golang(github.com/prometheus/client_golang/prometheus/graphite)
BuildRequires:  golang(github.com/prometheus/client_model/go)
BuildRequires:  golang(github.com/prometheus/common/expfmt)
BuildRequires:  golang(github.com/PuerkitoBio/goquery)
BuildRequires:  golang(github.com/rcrowley/go-metrics)
BuildRequires:  golang(github.com/rcrowley/go-metrics/exp)
BuildRequires:  golang(github.com/shirou/gopsutil/cpu)
BuildRequires:  golang(github.com/shirou/gopsutil/disk)
BuildRequires:  golang(github.com/shirou/gopsutil/host)
BuildRequires:  golang(github.com/shirou/gopsutil/load)
BuildRequires:  golang(github.com/shirou/gopsutil/mem)
BuildRequires:  golang(github.com/shirou/gopsutil/net)
BuildRequires:  golang(github.com/Shopify/sarama)
BuildRequires:  golang(github.com/Shopify/toxiproxy/client)
BuildRequires:  golang(github.com/spf13/cobra)
BuildRequires:  golang(github.com/spf13/cobra/doc)
BuildRequires:  golang(github.com/spf13/pflag)
BuildRequires:  golang(github.com/VividCortex/ewma)
BuildRequires:  golang(go.etcd.io/etcd/raft)
BuildRequires:  golang(go.etcd.io/etcd/raft/raftpb)
BuildRequires:  golang(golang.org/x/crypto/bcrypt)
BuildRequires:  golang(golang.org/x/crypto/ssh)
BuildRequires:  golang(golang.org/x/crypto/ssh/agent)
BuildRequires:  golang(golang.org/x/crypto/ssh/knownhosts)
BuildRequires:  golang(golang.org/x/crypto/ssh/terminal)
BuildRequires:  golang(golang.org/x/exp/rand)
BuildRequires:  golang(golang.org/x/net/html)
BuildRequires:  golang(golang.org/x/net/http2)
BuildRequires:  golang(golang.org/x/net/trace)
BuildRequires:  golang(golang.org/x/oauth2)
BuildRequires:  golang(golang.org/x/oauth2/google)
BuildRequires:  golang(golang.org/x/perf/storage)
BuildRequires:  golang(golang.org/x/sync/errgroup)
BuildRequires:  golang(golang.org/x/sync/syncmap)
BuildRequires:  golang(golang.org/x/sys/unix)
BuildRequires:  golang(golang.org/x/text/collate)
BuildRequires:  golang(golang.org/x/text/language)
BuildRequires:  golang(golang.org/x/text/unicode/norm)
BuildRequires:  golang(golang.org/x/time/rate)
BuildRequires:  golang(golang.org/x/tools/container/intsets)
BuildRequires:  golang(google.golang.org/api/iterator)
BuildRequires:  golang(google.golang.org/api/option)
BuildRequires:  golang(google.golang.org/grpc)
BuildRequires:  golang(google.golang.org/grpc/codes)
BuildRequires:  golang(google.golang.org/grpc/connectivity)
BuildRequires:  golang(google.golang.org/grpc/credentials)
BuildRequires:  golang(google.golang.org/grpc/encoding)
BuildRequires:  golang(google.golang.org/grpc/grpclog)
BuildRequires:  golang(google.golang.org/grpc/keepalive)
BuildRequires:  golang(google.golang.org/grpc/metadata)
BuildRequires:  golang(google.golang.org/grpc/peer)
BuildRequires:  golang(google.golang.org/grpc/stats)
BuildRequires:  golang(google.golang.org/grpc/status)
BuildRequires:  golang(gopkg.in/yaml.v2)
BuildRequires:  golang(vitess.io/vitess/go/sqltypes)
BuildRequires:  golang(vitess.io/vitess/go/vt/sqlparser)
BuildRequires:  procps-ng

%if %{with check}
# Tests
BuildRequires:  golang(github.com/stretchr/testify/assert)
BuildRequires:  golang(github.com/stretchr/testify/require)
%endif

%description
%{common_description}

%gopkg

%prep
%goprep
%patch0 -p1
# Newer grpc has moved transport to internal and StreamError has been removed
# https://github.com/grpc/grpc-go/commit/339b6cb107199486c3b352f70db9e977191be8b7
sed -i "/google.golang.org\/grpc\/transport/d" pkg/util/grpcutil/grpc_util.go
sed -i "s|err.(transport.StreamError); ok && streamErr.Code|status.FromError(err); ok \&\& streamErr.Code()|" pkg/util/grpcutil/grpc_util.go

%install
%gopkginstall

%if %{with check}
%check
%gocheck
%endif

%gopkgfiles

%changelog
* Thu Jul 25 2019 Fedora Release Engineering <releng@fedoraproject.org> - 19.2.0-5.alpha
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Tue Jul 02 01:41:53 CEST 2019 Robert-André Mauchin <zebob.m@gmail.com> - 19.2.0-4.alpha
- Fix patch

* Tue Jul 02 01:41:53 CEST 2019 Robert-André Mauchin <zebob.m@gmail.com> - 19.2.0-2.alpha
- Add patch for 32 bits compatibility

* Wed May 15 18:01:51 CEST 2019 Robert-André Mauchin <zebob.m@gmail.com> - 19.2.0-1.alpha
- Initial package
